Attribute VB_Name = "ImageMapSubs"
Option Explicit

'\\ Private reference to every running ImageMaplabel
'\\ item
Private colImageMapControls As Collection

'\\ API declarations used in subclassing
'\\ Get Window Long Indexes...
Const GWL_WNDPROC = (-4)
Private Declare Function GetWindowLongApi Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLongApi Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

'\\ Window message constants - for WndProc(wMsg).
Public Enum WindowMessages
 WM_ACTIVATE = &H6             '(LOWORD) wp = WA_, (HIWORD) > 0 if minimized, lp =hwnd
 WM_ACTIVATEAPP = &H1C
 WM_ASKCBFORMATNAME = &H30C
 WM_CANCELJOURNAL = &H4B
 WM_CANCELMODE = &H1F
 WM_CAPTURECHANGED = &H1F       'wParam = 0, lParam = New capture hWnd
 WM_CHANGECBCHAIN = &H30D
 WM_CHAR = &H102
 WM_CHARTOITEM = &H2F
 WM_CHILDACTIVATE = &H22
 WM_CHOOSEFONT_GETLOGFONT = (&H400 + 1)
 WM_CHOOSEFONT_SETFLAGS = (&H400 + 102)
 WM_CHOOSEFONT_SETLOGFONT = (&H400 + 101)
 WM_CLEAR = &H303
 WM_CLOSE = &H10
 WM_COMMAND = &H111
 WM_COMPACTING = &H41
 WM_COMPAREITEM = &H39
 WM_CONVERTREQUESTEX = &H108
 WM_COPY = &H301
 WM_COPYDATA = &H4A
 WM_CREATE = &H1
 WM_CTLCOLORBTN = &H135
 WM_CTLCOLORDLG = &H136
 WM_CTLCOLOREDIT = &H133
 WM_CTLCOLORLISTBOX = &H134
 WM_CTLCOLORMSGBOX = &H132
 WM_CTLCOLORSCROLLBAR = &H137
 WM_CTLCOLORSTATIC = &H138
 WM_CUT = &H300
 WM_DDE_ACK = (&H3E0 + 4)
 WM_DDE_ADVISE = (&H3E0 + 2)
 WM_DDE_DATA = (&H3E0 + 5)
 WM_DDE_EXECUTE = (&H3E0 + 8)
 WM_DDE_FIRST = &H3E0
 WM_DDE_INITIATE = &H3E0
 WM_DDE_LAST = (&H3E0 + 8)
 WM_DDE_POKE = (&H3E0 + 7)
 WM_DDE_REQUEST = (&H3E0 + 6)
 WM_DDE_TERMINATE = (&H3E0 + 1)
 WM_DDE_UNADVISE = (&H3E0 + 3)
 WM_DEADCHAR = &H103
 WM_DELETEITEM = &H2D
 WM_DESTROY = &H2
 WM_DESTROYCLIPBOARD = &H307
 WM_DEVMODECHANGE = &H1B
 WM_DRAWCLIPBOARD = &H308
 WM_DRAWITEM = &H2B
 WM_DROPFILES = &H233
 WM_ENABLE = &HA
 WM_ENDSESSION = &H16
 WM_ENTERIDLE = &H121
 WM_ENTERMENULOOP = &H211
 WM_ERASEBKGND = &H14  'wParam = 0, lParam = hDC of window.  Return 0 if intercepted...
 WM_EXITMENULOOP = &H212
 WM_FONTCHANGE = &H1D
 WM_GETDLGCODE = &H87
 WM_GETFONT = &H31
 WM_GETHOTKEY = &H33
 WM_GETMINMAXINFO = &H24
 WM_GETTEXT = &HD
 WM_GETTEXTLENGTH = &HE
 WM_HOTKEY = &H312
 WM_HSCROLL = &H114
 WM_HSCROLLCLIPBOARD = &H30E
 WM_ICONERASEBKGND = &H27
 WM_IME_CHAR = &H286
 WM_IME_COMPOSITION = &H10F
 WM_IME_COMPOSITIONFULL = &H284
 WM_IME_CONTROL = &H283
 WM_IME_ENDCOMPOSITION = &H10E
 WM_IME_KEYDOWN = &H290
 WM_IME_KEYLAST = &H10F
 WM_IME_KEYUP = &H291
 WM_IME_NOTIFY = &H282
 WM_IME_SELECT = &H285
 WM_IME_SETCONTEXT = &H281
 WM_IME_STARTCOMPOSITION = &H10D
 WM_INITDIALOG = &H110
 WM_INITMENU = &H116
 WM_INITMENUPOPUP = &H117
 WM_KEYDOWN = &H100
 WM_KEYUP = &H101
 WM_KILLFOCUS = &H8 'wParam = hWnd of window about to lose focus.
 WM_LBUTTONDBLCLK = &H203
 WM_LBUTTONDOWN = &H201
 WM_LBUTTONUP = &H202
 WM_MBUTTONDBLCLK = &H209
 WM_MBUTTONDOWN = &H207
 WM_MBUTTONUP = &H208
 WM_MDIACTIVATE = &H222
 WM_MDICASCADE = &H227
 WM_MDICREATE = &H220
 WM_MDIDESTROY = &H221
 WM_MDIGETACTIVE = &H229
 WM_MDIICONARRANGE = &H228
 WM_MDIMAXIMIZE = &H225
 WM_MDINEXT = &H224
 WM_MDIREFRESHMENU = &H234
 WM_MDIRESTORE = &H223
 WM_MDISETMENU = &H230
 WM_MDITILE = &H226
 WM_MEASUREITEM = &H2C
 WM_MENUCHAR = &H120
 WM_MENUSELECT = &H11F
 WM_MOUSEACTIVATE = &H21
 WM_MOUSEMOVE = &H200
 WM_MOVE = &H3
 WM_NCACTIVATE = &H86
 WM_NCCALCSIZE = &H83
 WM_NCCREATE = &H81
 WM_NCDESTROY = &H82
 WM_NCHITTEST = &H84
 WM_NCLBUTTONDBLCLK = &HA3
 WM_NCLBUTTONDOWN = &HA1
 WM_NCLBUTTONUP = &HA2
 WM_NCMBUTTONDBLCLK = &HA9
 WM_NCMBUTTONDOWN = &HA7
 WM_NCMBUTTONUP = &HA8
 WM_NCMOUSEMOVE = &HA0
 WM_NCPAINT = &H85
 WM_NCRBUTTONDBLCLK = &HA6
 WM_NCRBUTTONDOWN = &HA4
 WM_NCRBUTTONUP = &HA5
 WM_NEXTDLGCTL = &H28
 WM_NULL = &H0
 WM_PAINT = &HF
 WM_PAINTCLIPBOARD = &H309
 WM_PAINTICON = &H26
 WM_PALETTECHANGED = &H311
 WM_PALETTEISCHANGING = &H310
 WM_PARENTNOTIFY = &H210
 WM_PASTE = &H302
 WM_PENWINFIRST = &H380
 WM_PENWINLAST = &H38F
 WM_POWER = &H48
 WM_PSD_ENVSTAMPRECT = (&H400 + 5)
 WM_PSD_FULLPAGERECT = (&H400 + 1)
 WM_PSD_GREEKTEXTRECT = (&H400 + 4)
 WM_PSD_MARGINRECT = (&H400 + 3)
 WM_PSD_MINMARGINRECT = (&H400 + 2)
 WM_PSD_PAGESETUPDLG = (&H400)
 WM_PSD_YAFULLPAGERECT = (&H400 + 6)
 WM_QUERYDRAGICON = &H37
 WM_QUERYENDSESSION = &H11
 WM_QUERYNEWPALETTE = &H30F
 WM_QUERYOPEN = &H13
 WM_QUEUESYNC = &H23
 WM_QUIT = &H12
 WM_RBUTTONDBLCLK = &H206
 WM_RBUTTONDOWN = &H204
 WM_RBUTTONUP = &H205
 WM_RENDERALLFORMATS = &H306
 WM_RENDERFORMAT = &H305
 WM_SETCURSOR = &H20
 WM_SETFOCUS = &H7
 WM_SETFONT = &H30
 WM_SETHOTKEY = &H32
 WM_SETREDRAW = &HB
 WM_SETTEXT = &HC
 WM_SETTINGCHANGE = &H1A
 WM_SHOWWINDOW = &H18
 WM_SIZE = &H5
 WM_SIZECLIPBOARD = &H30B
 WM_SPOOLERSTATUS = &H2A
 WM_SYSCHAR = &H106
 WM_SYSCOLORCHANGE = &H15
 WM_SYSCOMMAND = &H112
 WM_SYSDEADCHAR = &H107
 WM_SYSKEYDOWN = &H104
 WM_SYSKEYUP = &H105
 WM_TIMECHANGE = &H1E
 WM_TIMER = &H113
 WM_UNDO = &H304
 WM_USER = &H400
 WM_VKEYTOITEM = &H2E
 WM_VSCROLL = &H115
 WM_VSCROLLCLIPBOARD = &H30A
 WM_WINDOWPOSCHANGED = &H47
 WM_WINDOWPOSCHANGING = &H46
 WM_WININICHANGE = &H1A
End Enum

'\\ --[GetValue]---------------------------------------------------------------
'\\ Returns the bit in a string that follows the valuename= bit
'\\ ---------------------------------------------------------------------------
Public Function GetValue(ByVal sHTML As String, ByVal ValueName As String) As String

Dim lStart As Long
Dim lEnd As Long

lStart = InStr(sHTML, ValueName & "=")
If lStart > 0 Then
    lStart = lStart + Len(ValueName) + 2
    lEnd = InStr(Mid$(sHTML, lStart), Chr$(34)) - 1
    If lEnd > 0 Then
        GetValue = Mid$(sHTML, lStart, lEnd)
    End If
End If

End Function

'\\ --[LoWord]-----------------------------------------------------------------------------
'\\ Returns the low word component of a long value
'\\ Parameters:
'\\   dw - The long of which we need the LoWord
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ You have a royalty free right to use, reproduce, modify, publish and mess with this code
'\\ I'd like you to visit http://www.merrioncomputing.com for updates, but won't force you
'\\ ----------------------------------------------------------------------------------------
Public Function LoWord(dw As Long) As Integer
  If dw And &H8000& Then
      LoWord = &H8000 Or (dw And &H7FFF&)
   Else
      LoWord = dw And &HFFFF&
   End If
End Function

'\\ --[HiWord]-----------------------------------------------------------------------------
'\\ Returns the high word component of a long value
'\\ Parameters:
'\\   dw - The long of which we need the HiWord
'\\
'\\ ----------------------------------------------------------------------------------------
'\\ You have a royalty free right to use, reproduce, modify, publish and mess with this code
'\\ I'd like you to visit http://www.merrioncomputing.com for updates, but won't force you
'\\ ----------------------------------------------------------------------------------------
Public Function HiWord(dw As Long) As Integer
 If dw And &H80000000 Then
      HiWord = (dw \ 65535) - 1
 Else
    HiWord = dw \ 65535
 End If
End Function

Public Sub ConnectImageMapControl(ByVal ctl As VBImageMap)

'\\ If this is the first control then initialise the collection
If colImageMapControls Is Nothing Then
    Set colImageMapControls = New Collection
End If

colImageMapControls.Add ctl, ctl.Key
With ctl
    .PreviousWindowProc = GetWindowLongApi(.hWnd, GWL_WNDPROC)
    Call SetWindowLongApi(.hWnd, GWL_WNDPROC, AddressOf VB_WindowProc)
End With

End Sub

Public Function MakeKey(ByVal ctlHwnd As Long) As String

    MakeKey = "KEY:" & ctlHwnd
    
End Function

Public Function QuoteString(ByVal sIn As String) As String

QuoteString = Chr$(34) & sIn & Chr$(34)

End Function

'\\ --[SetValue]-----------------------------------------------------------------------------------
'\\ Updates HTMLSnippet to set the ValueName= bit to be equal to the ValueContent passed in,
'\\ adding that ValueName= bit if it isn't already present.
'\\ -----------------------------------------------------------------------------------------------
Public Sub SetValue(ByVal ValueName As String, ByVal ValueContent As String, HTMLSnippet As String)

If GetValue(HTMLSnippet, ValueName) = "" Then
    '\\ The whole ValueName="ValueContent" needs adding if it is not blank...
    If ValueContent <> "" Then
        HTMLSnippet = Left$(HTMLSnippet, Len(HTMLSnippet) - 1) & " " & ValueName & "=" & QuoteString(ValueContent) & ">"
    End If
Else
    '\\ The ValueContent bit needs updating
    Dim nLeft As Long, nLength As Long
    nLeft = InStr(HTMLSnippet, ValueName & "=") + 1
    nLength = InStr(Mid$(HTMLSnippet, nLeft + 1), Chr$(34))
    Mid$(HTMLSnippet, nLeft, nLength) = ValueContent
End If

End Sub

'\\ --[VB_WindowProc]-------------------------------------------------------------------
'\\ 'typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
'\\ Parameters:
'\\   hwnd - window handle receiving message
'\\   wMsg - The window message (WM_..etc.)
'\\   wParam - First message parameter
'\\   lParam - Second message parameter
'\\ ----------------------------------------------------------------------------------------
'\\ You have a royalty free right to use, reproduce, modify, publish and mess with this code
'\\ I'd like you to visit http://www.merrioncomputing.com for updates, but won't force you
'\\ ----------------------------------------------------------------------------------------
Public Function VB_WindowProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


On Error Resume Next

Dim ctlThis As VBImageMap
Dim lRet As Long
Dim OverRide As Long

Set ctlThis = colImageMapControls.Item(MakeKey(hWnd))
With ctlThis
    '\\ Inform the control of its message
    .WindowProcFired wMsg, wParam, lParam, OverRide
    '\\ And pass the message on for default handling
    If OverRide = 0 Then
        lRet = CallWindowProc(.PreviousWindowProc, hWnd, wMsg, wParam, lParam)
    Else
        lRet = OverRide
    End If
End With


VB_WindowProc = lRet

End Function

'\\ --[CreateHTMLText]----------------------------------------------------
'\\ Puts together the HTML Text that represents an ImageMapItem
'\\ Format:
'\\ <area shape="rectangle"
'\\      target = "_top"
'\\      coords = "1,1,2,2"
'\\      href = "http://www.merrioncomputing.com/Download/index.htm"
'\\      id="toprect">
'\\ VB .Net porting note:  This function should be implemented as an
'\\ overloaded New() for the ImageMapItem
'\\ ----------------------------------------------------------------------
Public Function CreateHTMLText(ByVal id As String, ByVal Shape As enImageMapItemShapes, _
                               ByVal Target As enImageMapTargets, _
                               ByVal Coords As String, _
                               ByVal hRef As String) As String



End Function
